//+------------------------------------------------------------------+
//|                                              candlebased_001.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include "Trade_function.mq5"
#include "inputs.mq5"

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
      StopLoss =  SymbolInfoDouble(Symbol(),SYMBOL_POINT)*InpTrailingStopPoints;
      m_trailing_stop            = InpTrailingStopPoints       * SymbolInfo.Point();
      
      ArraySetAsSeries(Price_1,true);
      ArraySetAsSeries(Price_2,true);
      ArraySetAsSeries(Price_3,true);
      ArraySetAsSeries(Price_4,true);
      ArraySetAsSeries(Price_5,true);
      ArraySetAsSeries(Price_6,true);
     Trade.SetExpertMagicNumber(InpMagicNumber);
     
      if (Choice==1) Factor=1;
      if (Choice==2) Factor=2;
      if (Choice==3) Factor=3;
      if (Choice==4) Factor=4;
      if (Choice==5) Factor=5;
      if (Choice==10) Factor=10;
      if (Choice==20) Factor=20;
      if (Choice==30) Factor=30;
      if (Choice==40) Factor=40;
      if (Choice==50) Factor=50;
      if (Choice==100) Factor=100;
      
   Symbols[0]=C_Pair_0;
   Symbols[1]=C_Pair_1;
   Symbols[2]=C_Pair_2;
   Symbols[3]=C_Pair_3;
   Symbols[4]=C_Pair_4;
   Symbols[5]=C_Pair_5;
   Symbols[6]=C_Pair_6;
   Symbols[7]=C_Pair_7;
   Symbols[8]=C_Pair_8;
   Symbols[9]=C_Pair_9;
   Symbols[10]=C_Pair_10;
   Symbols[11]=C_Pair_11;
   Symbols[12]=C_Pair_12;
   Symbols[13]=C_Pair_13;
   Symbols[14]=C_Pair_14;
   Symbols[15]=C_Pair_15;
   Symbols[16]=C_Pair_16;
   Symbols[17]=C_Pair_17;
   Symbols[18]=C_Pair_18;
   Symbols[19]=C_Pair_19;
   
   
   //--- Check for the symbol in the Market Watch
   for(int i=0; i<Fx_Currencies; i++)
     {
      if(IsTrade[i]==false) continue;
      if(IsSymbolInMarketWatch(Symbols[i])==false)
        {
         Print(Symbols[i]," could not be found on the server!");
         ExpertRemove();
        }
      SymbolInfo.Name(Symbols[i]);
      //--- number of decimal places
      digits_arr[i]=SymbolInfo.Digits();
      //--- point value
      Points[i]=SymbolInfo.Point();
      SymbolInfo.RefreshRates();
     
     }
    
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnTick()
  {
      int Data_1 =  CopyRates(Symbol(),Period_1,0,5,Price_1);
      int Data_2 =  CopyRates(Symbol(),Period_2,0,5,Price_2);
      int Data_3 =  CopyRates(Symbol(),Period_3,0,5,Price_3);
      int Data_4 =  CopyRates(Symbol(),Period_4,0,5,Price_4);
      int Data_5 =  CopyRates(Symbol(),Period_5,0,5,Price_5);
      int Data_6 =  CopyRates(Symbol(),Period_6,0,5,Price_6);
   
   for(int s=Fx_Currencies-1;s>=0;s--)
     { 
      Trade_function(Symbols[s],InpMagicNumber);
      ApplyTrailingStoploss(Symbols[s],InpMagicNumber,StopLoss);
     // Trade_function(Symbols[s]);
     }
  }

//+------------------------------------------------------------------+
void Buy()
  {for(int buy=0; buy<Fx_Currencies; buy++){
   
   if(!Trade.Buy(Lotsize,Symbols[buy],Ask,0.0,0.0))
           {
            Print("The Buy ",Symbols[buy]," has been unsuccessful. Code=",Trade.ResultRetcode(),
                  " (",Trade.ResultRetcodeDescription(),")");
            continue; // terminate the current FOR iteration
           }
         else
           {
            Print("The Buy ",Symbols[buy]," has been successful. Code=",Trade.ResultRetcode(),
                  " (",Trade.ResultRetcodeDescription(),")");
            continue; // terminate the current FOR iteration
      }  
  }
  } 
void Sell()
  {
    for(int sell=0; sell<Fx_Currencies; sell++){
      
      if(!Trade.Sell(Lotsize,Symbols[sell],Bid,0.0,0.0))
           {
            Print("The Sell ",Symbols[sell]," has been unsuccessful. Code=",Trade.ResultRetcode(),
                  " (",Trade.ResultRetcodeDescription(),")");
            continue; // terminate the current FOR iteration
           }
         else
           {
            Print("The Sell ",Symbols[sell]," has been successful. Code=",Trade.ResultRetcode(),
                  " (",Trade.ResultRetcodeDescription(),")");
            continue; // terminate the current FOR iteration
           }
      }
  
  }
void  ApplyTrailingStoploss(string symbol, int magicNumber, double stopLoss){
       for(int B=0; B<Fx_Currencies; B++)
     {
      //--- B.1: Check whether the symbol is allowed to be traded
      if(IsTrade[B]==false)
         continue; // terminate the current FOR iteration
      if(PositionSelect(Symbols[B])) {
         double buystopLoss=NormalizeDouble(PositionInfo.PriceOpen()-StopLoss_arr[B]*Points[B],
                              digits_arr[B]);
         double sellstopLoss=NormalizeDouble(PositionInfo.PriceOpen()+StopLoss_arr[B]*Points[B],
                              digits_arr[B]);  
         
         if(PositionInfo.StopLoss()==0) {
            if(PositionInfo.PositionType()==POSITION_TYPE_BUY
               && buystopLoss>PositionGetDouble(POSITION_PRICE_OPEN)){
               
               if(!Trade.PositionModify(Symbols[B],buystopLoss,0))
                 {
                  Print("Failed to modify the Buy ",Symbols[B]," position. Code=",Trade.ResultRetcode(),
                        " (",Trade.ResultRetcodeDescription(),")");
                  continue; // terminate the current FOR iteration
                 }
               else
                 {
                  Print("The Buy ",Symbols[B]," position has been modified successfully. Code=",Trade.ResultRetcode(),
                        " (",Trade.ResultRetcodeDescription(),")");
                  continue; // terminate the current FOR iteration
                 }
              }

            //--- B.7.2: Modify a Sell position
            if(PositionInfo.PositionType()==POSITION_TYPE_SELL
               && sellstopLoss<PositionGetDouble(POSITION_PRICE_OPEN))
              {
                if(!Trade.PositionModify(Symbols[B],sellstopLoss,0)) {
                  
                  Print("Failed to modify the Sell ",Symbols[B]," position. Code=",Trade.ResultRetcode(),
                        " (",Trade.ResultRetcodeDescription(),")");
                  continue; // terminate the current FOR iteration
                 }
               else
                 {
                  Print("The Sell ",Symbols[B]," position has been modified successfully. Code=",Trade.ResultRetcode(),
                        " (",Trade.ResultRetcodeDescription(),")");
                  continue; // terminate the current FOR iteration
                 }
              }
           }
        }
   }
}  

//--- The IsSymbolInMarketWatch() function
bool IsSymbolInMarketWatch(string f_Symbol)
  {
   for(int s=0; s<SymbolsTotal(false); s++)
     {
      if(f_Symbol==SymbolName(s,false))
         return(true);
     }
   return(false);
  }