//+------------------------------------------------------------------+
//|                                                       inputs.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#define   Fx_Currencies 20
#include <Trade\AccountInfo.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\Trade.mqh>
#include <Trade\Trade.mqh>
CTrade         Trade;
CAccountInfo   AccountInfo;
CPositionInfo  PositionInfo;
CSymbolInfo    SymbolInfo;
#include "Trade_function.mq5"
#include "MoneyBin.mq5"

MqlRates Price_1[];
MqlRates Price_2[];
MqlRates Price_3[];
MqlRates Price_4[];
MqlRates Price_5[];
MqlRates Price_6[];

input ENUM_TIMEFRAMES   Period_1        =  PERIOD_H12;
input ENUM_TIMEFRAMES   Period_2        =  PERIOD_H8;
input ENUM_TIMEFRAMES   Period_3        =  PERIOD_H6;
input ENUM_TIMEFRAMES   Period_4        =  PERIOD_H4;
input ENUM_TIMEFRAMES   Period_5        =  PERIOD_H2;
input ENUM_TIMEFRAMES   Period_6        =  PERIOD_H1;

input int      start_1                  =  50;
input int      start_2                  =  75;
input int      start_3                  =  89;
input int      start_4                  =  102;
input int      start_5                  =  114;
input int      start_6                  =  125;


input bool     IsTradable              =  true;
input int      InpTrailingStopPoints   =  100;
input double   Lotsize                 =  0.01;    

input int      InpMagicNumber          =  202020;


enum Increase_factor
  {
   First=1,
   Second=2,
   Third=3,
   Forth=4,
   Fifth=5,
   Tenth=10,
   Twentieth=20,
   Thirtieth=30,
   Fortieth=40,
   Fiftieth=50,
   Hundredth=100,
  };
input    Increase_factor Choice=First;
int      Factor;

input    string   C_Pair_0       = "USDJPY";
input    string   C_Pair_1       = "USDCHF";
input    string   C_Pair_2       = "USDCAD";
input    string   C_Pair_3       = "GBPUSD";
input    string   C_Pair_4       = "GBPJPY";
input    string   C_Pair_5       = "GBPCHF";
input    string   C_Pair_6       = "EURUSD";
input    string   C_Pair_7       = "EURNZD";
input    string   C_Pair_8       = "EURJPY";
input    string   C_Pair_9       = "EURGBP";
input    string   C_Pair_10      = "EURCHF";
input    string   C_Pair_11      = "EURCAD";
input    string   C_Pair_12      = "EURAUD";
input    string   C_Pair_13      = "CHFJPY";
input    string   C_Pair_14      = "CADCHF";
input    string   C_Pair_15      = "AUDUSD";
input    string   C_Pair_16      = "AUDNZD";
input    string   C_Pair_17      = "AUDJPY";
input    string   C_Pair_18      = "AUDCHF";
input    string   C_Pair_19      = "AUDCAD";


double   equity            =  AccountInfoDouble(ACCOUNT_EQUITY);
double   StopLoss_arr[Fx_Currencies];
double   StopLoss;
int      C_Pair_arr[];
double   Points[Fx_Currencies];
int      digits_arr[Fx_Currencies];
string   Symbols[Fx_Currencies];
bool     IsTrade[Fx_Currencies];
double   Ask=SymbolInfo.Ask();
double   Bid=SymbolInfo.Bid();
string   m_symbol=SymbolInfo.Name();
double   m_trailing_stop            = 0.0;