//+------------------------------------------------------------------+
//|                                           MoneyBinCandleBase.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"


#include    <Trade/Trade.mqh>
CTrade      Trade;

MqlRates Price_1[];
MqlRates Price_2[];
MqlRates Price_3[];
MqlRates Price_4[];
MqlRates Price_5[];
MqlRates Price_6[];

input ENUM_TIMEFRAMES   Period_1        =  PERIOD_H12;
input ENUM_TIMEFRAMES   Period_2        =  PERIOD_H8;
input ENUM_TIMEFRAMES   Period_3        =  PERIOD_H6;
input ENUM_TIMEFRAMES   Period_4        =  PERIOD_H4;
input ENUM_TIMEFRAMES   Period_5        =  PERIOD_H2;
input ENUM_TIMEFRAMES   Period_6        =  PERIOD_H1;

input int      start_1                  =  50;
input int      start_2                  =  75;
input int      start_3                  =  89;
input int      start_4                  =  102;
input int      start_5                  =  114;
input int      start_6                  =  125;


input int      InpTrailingStopPoints   =  100;
input double   Lotsize                 =  0.01;    

input int      InpMagicNumber          =  202020;


double   StopLoss;
double   equity            =  AccountInfoDouble(ACCOUNT_EQUITY);
enum Increase_factor
  {
   First=1,
   Second=2,
   Third=3,
   Forth=4,
   Fifth=5,
   Tenth=10,
   Twentieth=20,
   Thirtieth=30,
   Fortieth=40,
   Fiftieth=50,
   Hundredth=100,
  };
input    Increase_factor Choice=First;
int      Factor;

void OnInit(void){
      StopLoss =  SymbolInfoDouble(Symbol(),SYMBOL_POINT)*InpTrailingStopPoints;
      ArraySetAsSeries(Price_1,true);
      ArraySetAsSeries(Price_2,true);
      ArraySetAsSeries(Price_3,true);
      ArraySetAsSeries(Price_4,true);
      ArraySetAsSeries(Price_5,true);
      ArraySetAsSeries(Price_6,true);
     Trade.SetExpertMagicNumber(InpMagicNumber);
     
      if (Choice==1) Factor=1;
      if (Choice==2) Factor=2;
      if (Choice==3) Factor=3;
      if (Choice==4) Factor=4;
      if (Choice==5) Factor=5;
      if (Choice==10) Factor=10;
      if (Choice==20) Factor=20;
      if (Choice==30) Factor=30;
      if (Choice==40) Factor=40;
      if (Choice==50) Factor=50;
      if (Choice==100) Factor=100;
      
     }
void OnTick(){
      int Data_1 =  CopyRates(Symbol(),Period_1,0,5,Price_1);
      int Data_2 =  CopyRates(Symbol(),Period_2,0,5,Price_2);
      int Data_3 =  CopyRates(Symbol(),Period_3,0,5,Price_3);
      int Data_4 =  CopyRates(Symbol(),Period_4,0,5,Price_4);
      int Data_5 =  CopyRates(Symbol(),Period_5,0,5,Price_5);
      int Data_6 =  CopyRates(Symbol(),Period_6,0,5,Price_6);
   
      Trade_function(Symbol(),InpMagicNumber);
      ApplyTrailingStoploss(Symbol(),InpMagicNumber,StopLoss);
}
void Trade_function(string symbol, int magicNumber){
      int   start1   =  Factor*start_1;
      int   start2   =  Factor*start_2;
      int   start3   =  Factor*start_3;
      int   start4   =  Factor*start_4;
      int   start5   =  Factor*start_5;
      int   start6   =  Factor*start_6;  
  
  // At this point, use a for loop to loop through all the available symbols.
  
  if(PositionGetString(POSITION_SYMBOL)==symbol   
      && PositionGetInteger(POSITION_MAGIC)==magicNumber){
      if(equity>=start1){if(Price_1[1].close){Buy(); Sell();}}
      if(equity>=(start2*2)-(start1)){if(Price_2[1].close){Buy(); Sell();}}
      if(equity>=(start3*3)-(start2*2)){if(Price_3[1].close){Buy(); Sell();}}
      if(equity>=(start4*4)-(start3*3)){if(Price_4[1].close){Buy(); Sell();}}
      if(equity>=(start5*5)-(start4*4)){if(Price_5[1].close){Buy(); Sell();}}
      if(equity>=(start6*6)-(start5*5)){if(Price_6[1].close){Buy(); Sell();}}
      
  }
}
void  ApplyTrailingStoploss(string  symbol,int  magicNumber, double  stoploss){
      
      static   int   digits   =  (int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
      
      // Trailing from the close prices.
      double   buyStoploss    =  NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_BID)-stoploss,digits);
      double   sellStoploss   =  NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_ASK)+stoploss,digits);
      
      int   count       =  PositionsTotal();
      for(int i=count-1;i>=0;i--){
         ulong ticket   =  PositionGetTicket(i);
         if(ticket>0){
            if(PositionGetString(POSITION_SYMBOL)==symbol   
            && PositionGetInteger(POSITION_MAGIC)==magicNumber){
               
               // apply trailing stops.
               if(PositionGetInteger(POSITION_TYPE)==ORDER_TYPE_BUY     // if it is a buy order,
               && buyStoploss>PositionGetDouble(POSITION_PRICE_OPEN)    // & buy sl > open price.only appears when sl is past open price.
               && (PositionGetDouble(POSITION_SL)==0                    // current sl position.
               || buyStoploss>PositionGetDouble(POSITION_SL)))          // or new calculated sl > current sl for the position.
               {
                  Trade.PositionModify(ticket,buyStoploss,
                  PositionGetDouble(POSITION_TP)                // current tp for that position.
                  );
                  }  else if(PositionGetInteger(POSITION_TYPE)==ORDER_TYPE_SELL 
               && sellStoploss<PositionGetDouble(POSITION_PRICE_OPEN)
               && (PositionGetDouble(POSITION_SL)==0  || sellStoploss<PositionGetDouble(POSITION_SL))){
                  Trade.PositionModify(ticket,sellStoploss,PositionGetDouble(POSITION_TP));      
                       }
                  }
              }
         }   
}

void Buy()
  {
  double    buyLot   =  Lotsize*Factor;
  double    Ask  =  NormalizeDouble(SymbolInfoDouble(Symbol(),SYMBOL_ASK),Digits());
  Trade.Buy(buyLot,NULL,Ask,0,0,"Buy Order");
  }
void Sell()
  {
  double    sellLot  =  Lotsize*Factor;
  double    Bid  =  NormalizeDouble(SymbolInfoDouble(Symbol(),SYMBOL_BID),Digits());
  Trade.Sell(sellLot,NULL,Bid,0,0,"Sell Order");
  }